#include "gis.h"

char *G_calloc();

double *
G_alloc_vector(n)
    int n;
{
    return (double *) G_calloc (n, sizeof(double));
}

double **
G_alloc_matrix(rows, cols)
    int rows, cols;
{
    double **m;
    int i;

    m = (double **) G_calloc (rows, sizeof(double *));
    m[0] = (double *) G_calloc (rows*cols, sizeof(double));
    for (i = 1; i < rows; i++)
	m[i] = m[i-1] + cols;
    return m;
}

G_free_vector(v)
    double *v;
{
    free ((char *)v);
}

G_free_matrix(m)
    double **m;
{
    free ((char *)(m[0]));
    free ((char *)m);
}

int *
G_alloc_ivector(n)
    int n;
{
    return (int *) G_calloc (n, sizeof(int));
}

int **
G_alloc_imatrix(rows, cols)
    int rows, cols;
{
    int **m;
    int i;

    m = (int **) G_calloc (rows, sizeof(int *));
    m[0] = (int *) G_calloc (rows*cols, sizeof(int));
    for (i = 1; i < rows; i++)
	m[i] = m[i-1] + cols;
    return m;
}

G_free_ivector(v)
    int *v;
{
    free ((char *)v);
}

G_free_imatrix(m)
    int **m;
{
    free ((char *)(m[0]));
    free ((char *)m);
}
