#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include "gis.h"

#define LIKELIHOOD float

#ifdef CLASS_TYPE_SHORT
# define IMAGE_CLASS unsigned short
# define MAX_IMAGE_CLASS 65535
#else
# define IMAGE_CLASS unsigned char
# define MAX_IMAGE_CLASS 255
#endif

/* Subroutines in interp.c */
void seq_MAP();
void MLE();

/* Subroutines in decimate.c */
void make_pyramid();
char ***get_pyramid();
void free_pyramid();
char ****get_cubic_pyramid();
void free_cubic_pyramid();
int levels();

/* Subroutines in reg_util.c */
int levels_reg();
void dec_reg();
void copy_reg();
void reg_to_wdht();

/* Subroutines in model.c */
void extract();
void extract_init();

/* Subroutines in multialloc.c */
char *multialloc();
void multifree();
char **get_img();
void free_img();

/* Subroutines in io.c */
void writearray();
void readarray();
void write_img();
void write_class_img();
void read_img();

/* Subroutine in solve.c */
double  solve();

/* Subroutine in eigen.c */
void eigen();

/* Subroutine in invert.c */
int invert();

/* Subroutine in alloc.c */
char *G_malloc();
char *G_calloc();
char *G_realloc();


void exit();

